diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
index f390ed53b..973e02383 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
@@ -15,7 +15,7 @@ public class BlockModelCandle<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         boolean isLit = (worldSource.getBlockData(tilePos) & 0b00000001) == 0;
         float brightness = isLit ? 1.0f : renderBlocks.getBlockBrightness(worldSource, tilePos);
 
@@ -59,7 +59,7 @@ public class BlockModelCandle<T extends BlockLogic> extends BlockModelStandard<T
         double wickMaxV = texIndex.getSubIconV(onePix * 6);
 
 
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
 
         // Render sides
         tessellator.addVertexWithUV(maxX, minY, minZ, sideMinU, sideMaxV);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
index 0dcb496d4..d1f4a7069 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.*;
@@ -46,7 +46,7 @@ public class BlockModelChest<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int meta = worldSource.getBlockData(tilePos);
         final Direction dir = BlockLogicChest.getDirectionFromMeta(meta);
         switch (dir) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
index a7889c1d1..037ddb1c4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
@@ -1,9 +1,8 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
@@ -33,14 +32,10 @@ public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStan
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
 
         final int meta = worldSource.getBlockData(tilePos);
         IconCoordinate leafTexture = LEAF_TEXTURE;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
index f55d93447..6d74c9318 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
@@ -1,9 +1,8 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicCropsWheat;
@@ -32,14 +31,10 @@ public class BlockModelCropsWheat<T extends BlockLogic> extends BlockModelStanda
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
 
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, worldSource.getBlockData(tilePos));
         if (renderBlocks.overrideBlockTexture != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index 25f506ac0..7b185aa07 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.Blocks;
@@ -11,8 +11,6 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelCrossedSquares(Block<T> block) {
@@ -20,25 +18,10 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (LightmapHelper.isLightmapEnabled()) {
-            brightness = 1f;
-        }
-        float r = 1f;
-        float g = 1f;
-        float b = 1f;
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
         // Used for the rendering for the block inside the jar
-        GL11.glColor4f(1f, 1f, 1f, 1f);
-        if (renderBlocks.useInventoryTint) {
-            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-            r = (float) (color >> 16 & 0xff) / 255F;
-            g = (float) (color >> 8 & 0xff) / 255F;
-            b = (float) (color & 0xff) / 255F;
-        }
         final float yOffset = 0.0F;
 
-        GL11.glTranslatef(-0.5F, -0.5f, -0.5F);
-
         IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata);
         if (renderBlocks.overrideBlockTexture != null) {
             texIndex = renderBlocks.overrideBlockTexture;
@@ -48,11 +31,10 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
         final double minV = texIndex.getIconVMin();
         final double maxV = texIndex.getIconVMax();
 
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_F(r * brightness, g * brightness, b * brightness, alpha);
-        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null) {
-            tessellator.setLightmapCoord(lightmapCoordinate);
-        }
+        tessellator.setColor1i(getStandaloneTintColor(metadata));
+        tessellator.setLightmapCoord1i(lightmapCoord);
 
         double xd = 0;
         double yd = 0;
@@ -82,23 +64,18 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
         tessellator.addVertexWithUV(minX, yd + 0.0D, maxZ, maxU, maxV);
         tessellator.addVertexWithUV(minX, yd + 1.0D + yOffset, maxZ, maxU, minV);
         tessellator.draw();
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
-        float brightness = 1.0f;
-        if (!LightmapHelper.isLightmapEnabled()) {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        } else {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        }
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
 
         int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
         float r = (float) (color >> 16 & 0xff) / 255F;
         float g = (float) (color >> 8 & 0xff) / 255F;
         float b = (float) (color & 0xff) / 255F;
-        tessellator.setColorOpaque_F(brightness * r, brightness * g, brightness * b);
+        tessellator.setColorOpaque3f(r, g, b);
 
         double xd = tilePos.x();
         double yd = tilePos.y();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
index f25fd0de9..e6d315aaa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
@@ -1,7 +1,8 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
@@ -9,9 +10,7 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelCrystallineNetherrack<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate overlay;
@@ -22,7 +21,7 @@ public class BlockModelCrystallineNetherrack<T extends BlockLogic> extends Block
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
         renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = this.overlay;
@@ -32,45 +31,35 @@ public class BlockModelCrystallineNetherrack<T extends BlockLogic> extends Block
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
         renderBlocks.useInventoryTint = false;
-        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
         renderBlocks.useInventoryTint = true;
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
-
-        int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-        float r = (float) (color >> 16 & 0xff) / 255F;
-        float g = (float) (color >> 8 & 0xff) / 255F;
-        float b = (float) (color & 0xff) / 255F;
-        GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
 
         AABBdc bounds = this.block.getBounds();
-        IconCoordinate coord = this.overlay;
+        IconCoordinate tex = this.overlay;
 
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
+        tessellator.setColor1i(BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0));
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, tex);
+
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, tex);
+
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, tex);
+
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, tex);
+
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
-        tessellator.draw();
-        tessellator.startDrawingQuads();
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, tex);
+
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, coord);
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, tex);
         tessellator.draw();
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index dade5a67e..0405aa8ff 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.util.helper.Side;
@@ -17,22 +17,15 @@ public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard
         super(block);
     }
 
-    public void setBrightness(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, float sideBrightness) {
-        float brightness = sideBrightness;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            brightness *= renderBlocks.getBlockBrightness(worldSource, tilePos);
-        }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+    public void setBrightness(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, float sideBrightness) {
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        tessellator.setColorOpaque3f(sideBrightness, sideBrightness, sideBrightness);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
-        }
-        tessellator.setColorOpaque_F(1.0f, 1.0f, 1.0f);
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        tessellator.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
+        tessellator.setColorOpaque3f(1.0f, 1.0f, 1.0f);
 
         AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
         TilePos queryPos = new TilePos();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
index 36d0d7d2b..a8264f99d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -16,12 +17,12 @@ public class BlockModelEmpty<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(final @NotNull TessellatorTerrain tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         return false;
     }
 
     @Override
-    public void renderStandalone(@NotNull final Tessellator tessellator, final int metadata, final float brightness, final float alpha, @Nullable final Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull final TessellatorGeneral tessellator, final int metadata, final int lightmapCoord) {
 
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 8ffd6326b..27005cdf9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -1,17 +1,15 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFence;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelFence<T extends BlockLogicFence> extends BlockModelStandard<T> {
@@ -26,7 +24,7 @@ public class BlockModelFence<T extends BlockLogicFence> extends BlockModelStanda
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         final float f = 0.375F;
         final float f1 = 0.625F;
         AABBd bounds = new AABBd(f, 0.0F, f, f1, 1.0F, f1);
@@ -77,15 +75,10 @@ public class BlockModelFence<T extends BlockLogicFence> extends BlockModelStanda
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (renderBlocks.useInventoryTint) {
-            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-            float r = (float) (color >> 16 & 0xff) / 255F;
-            float g = (float) (color >> 8 & 0xff) / 255F;
-            float b = (float) (color & 0xff) / 255F;
-            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-        }
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
+        tessellator.startDrawingQuads();
+        tessellator.setColor1i(getStandaloneTintColor(metadata));
         for (int cube = 0; cube < 4; cube++) {
 
             AABBdc bounds;
@@ -100,36 +93,26 @@ public class BlockModelFence<T extends BlockLogicFence> extends BlockModelStanda
                 default -> new AABBd(0.5F - f5, 0.5F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 0.5F - f5, 1.0F + f5 * 2.0F);
             };
 
-            tessellator.startDrawingQuads();
+
             tessellator.setNormal(0.0F, -1F, 0.0F);
             renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
             renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
             renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
             renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
             renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
             renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
-            tessellator.draw();
         }
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.draw();
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 }
